//////////////////////////////////////////////////////
///////////////////////Waffen/////////////////////////
//////////////////////////////////////////////////////


//////////////////////Partikel////////////////////////
Function spec_fun()
{
    my.alpha -= 5 *time;
    IF(My.alpha < 0) { my.alpha = 0; my.lifespan = 0; }
}

Function Wassereinschuss_spec_fun()
{
    if(my.size > 0) { my.size -= 0.100 *time; }else{my.lifespan = 0; }
    my.alpha -= 2 *time;
    if(My.alpha < 0) { my.alpha = 0; my.lifespan = 0; }
}

Function Blut()	//Blut Partikel wenn ein Spieler getroffen wird
{
    my.blue = 0;
    my.green = 0;
    my.red = 255;
    my.bmap = BlutBmap;  //the effect bitmap
    my.vel_x = random( 1.709 ) - 0.854 ;
    my.vel_y = random( 1.709 ) - 0.854 ;
    my.vel_z = random( 1.709 );
    my.size = 3.150;
    my.alpha = 70;	//50
    my.gravity = 0.420;
    my.streak = on;
    my.move = on;
    my.transparent = on;
    my.function = spec_fun;
}

Function Funken()	//Funken bei Hauswnden usw.
{
    my.blue = 42.496;
    my.green = 62.820;
    my.red = 255;
    my.bmap = ray_farbe1; //the effect bitmap
    my.vel_x = random( 1.709 ) - 0.854;
    my.vel_y = random( 1.709 ) - 0.854;
    my.vel_z = random( 1.709 );
    my.size = 5;
    my.alpha = 50;
    my.gravity = 0.420;
    my.streak = on;
    my.flare = on;
    my.bright = on;
    my.move = on;
    my.transparent = on;
    my.function = spec_fun;
}

Function Wassereinschuss()	//Spritzen bei Wassereinschuss
{
    my.blue = 177.375 ;
    my.green = 144.117 ;
    my.red = 144.117 ;
    my.vel_x = random( 1.500 ) - 0.750 ;
    my.vel_y = random( 1.500 ) - 0.750 ;
    my.vel_z = random( 4 );
    my.size = 1 ;
    my.alpha = 50 ;
    my.gravity = 0.398 ;
    my.streak = off;
    my.flare = on;
    my.bright = on;
    my.beam = off;
    my.move = on;
    my.transparent = on;
    my.function = Wassereinschuss_spec_fun;
}

//////////////////////Kugel////////////////////////
function Schaden_Kugel	//event der Kugel:wenn ein Spieler getroffen wurde wird diesem
{								//energie abgezogen und Blutpartikel werden erstellt
//	while(me)				//bzw. wenn es kein Spieler ist werden Einschusslcher
//	{
		if(my.flag1 == off)
		{
			if(you)
			{
				if(you.Oberflache == 0)
				{
					effect(Funken,max(1,my.Partikelzahl*2),my.x,nullvector);	//20
					wait(1);
					ent_morph(me,"bullet_hole.tga");
					my.transparent = on;
					my.bright = on;
					my.flag1 = on;
				}else
				{
					if(you.Oberflache == Haut)
					{
						you.health -= (my.Schaden-random(my.Schaden));
						effect(Blut,max(1,my.Partikelzahl),my.x,nullvector);
						wait(2);
						ent_remove(me);
					}else
					{
						if(you.Oberflache == Wasser)
						{
							effect(Wassereinschuss,my.Partikelzahl,my.x,nullvector);
							wait(2);
							my.flag1 = on;
//							ent_remove(me);
						}
					}
				}
			}else
			{
				effect(Funken,max(1,my.Partikelzahl*time),my.x,nullvector);	//20
				wait(1);
				ent_morph(me,"bullet_hole.tga");
				my.flag1 = on;
			}
		}else
		{
			sleep(5);
			ent_remove(me);
		}
//		wait(1);
//	}
}

function Kugel_weg	//Funktion um das Kollidieren zwischen Kugel und Waffe zu verhindern.
{
	wait(1);
	my.passable = off;
}

function Kugel			//Action der Kugel: Kugel wird bewegt und fr Events sensibilisiert.
{
	my.scale_x = 0.1;
	my.scale_y = 0.1;
	my.scale_z = 0.1;
	my.passable = on;
	my.polygon = on;
	my.fat = off;
	my.narrow = off;
	my.flag8 = on;
	my.enable_entity = on;
	my.enable_block = on;
	my.event = Schaden_Kugel;
	Kugel_weg();
	while(me)
	{
		my.skill1 = c_move(me,vector(my.Kugeltempo*time,0,0),nullvector,null);	//200
		wait(1);
		if(!me){break;}
		if(my.skill1 < 0){break;}
	}
}

////////////////////////Waffe//////////////////////
function next_Shot	//Function in welche die Feuerrate bestimmt.
{
	my.flag2 = on;
	sleep(my.Feuerrate);
	my.flag2 = off;
}

function nachladen
{
	my.flag3 = on;
	my.magazine -= 1;
	sleep(my.nachlade_Zeit);
	my.skill23 = my.Muni_Magazin;
	my.flag3 = off;
}

function Munitions_anz()	//schreibe den String fr die Munitionsanzeige
{
	str_for_num(munitions_str,my.skill23);
	str_cat(munitions_str,"/");
	str_for_num(muni_maga,my.Muni_Magazin);
	str_cat(munitions_str,muni_maga);
	str_for_num(Anzahl_Maga,my.Magazine);
	str_cat(munitions_str,"    ");
	str_cat(munitions_str,Anzahl_Maga);
}

//uses:Kugel_mdl,Feuerrate,KugelTempo,Schaden,Partikelzahl,Magazine,Muni_Magazin,Muni_Typ,Nachlade_Zeit
action Waffe														//Action der Waffe: Die Waffe dreht sich
{																		//wenn sie auf dem Boden liegt und wird
	my.passable = on;												//sonst dem Spieler der sie aufgesammelt hat
	my.oberflache = Waffe_surf;								//an die Hand gesetzt wo sie dann mit linker
	if(my.Feuerrate == 0){my.Feuerrate = 0.2;}			//Maustaste geschossen werden kann wobei die
	if(my.Kugeltempo == 0){my.Kugeltempo = 200;}			//Kugeln erstellt werden. auf "R" kann man
	if(my.Schaden == 0){my.Schaden = 70;}					//nachladen.
	if(my.Partikelzahl == 0){my.Partikelzahl = 25;}
	if(my.Magazine == 0){my.Magazine = 3;}
	if(my.Muni_Magazin == 0){my.Muni_Magazin = 23;}
	if(my.nachlade_Zeit == 0){my.Nachlade_Zeit = 3;}
	if(my.Kugel_mdl == 0){my.Kugel_mdl = "Huelse.mdl";}
//	if(my.Schuss_wav == 0){my.Schuss_wav = "Schuss1.wav";}
	
//	var Schuss_sound;
//	Schuss_sound = snd_create(my.Schuss_wav);
	
	my.skill23 = my.Muni_Magazin;
	my.magazine -= 1;
	
	while(1)
	{
	/*	my.polygon = on;
		my.fat = off;
		my.narrow = off;*/
		my.scale_x = 1;
		my.scale_y = 1;
		my.scale_z = 1;
		while(my.flag1 == off)
		{
			my.skill21 = c_trace(my.x,vector(my.x,my.y,my.z-10000),ignore_me+use_box);
			if(my.floor_dist > 33)	//(my.skill21 > 20)
			{
				my.z -= 10*time;
			}
			c_scan(my.x,my.pan,vector(360,360,100),ignore_me|scan_ents);
			if(you)
			{
				if(player)
				{
					if(you == player && key_f)
					{
						my.flag1 = on;
						my.skill22 = Handle(you);
						Muni.visible = on;
					}
				}
			}
			
			c_rotate(me,vector(5*time,0,0),ACTIVATE_TRIGGER);
			
			wait(1);
		}
		my.passable = on;
		my.scale_x = 0.2;
		my.scale_y = 0.2;
		my.scale_z = 0.2;
		while(my.flag1 == on)
		{
			you = ptr_for_handle(my.skill22);
			vec_for_vertex(my.x,you,you.Waffen_vertex);
			vec_set(my.pan,camera.pan);
			
			if(you.health <= 0){my.flag1 = off; if(you == player){Muni.visible = off;}}
			if(player)
			{
				if(you == player)
				{ 
					if(key_t)
					{
						my.flag1 = off;
						Muni.visible = off;
					}
				
					if(mouse_left && my.flag2 == off && my.skill23 > 0)
					{
//						snd_play(Schuss_sound,100,0);
						you = ent_create(my.string1,my.x,Kugel);
						vec_set(you.pan,my.pan);
						you.Kugeltempo = my.Kugeltempo;
						you.Schaden = my.Schaden;
						you.Partikelzahl = my.Partikelzahl;
						you.skill10 = my.skill10;
						my.skill23 -= 1;
						next_Shot();
					}
			
					if(key_r && my.flag3 == off && my.magazine > 0)
					{
						nachladen();
					}
					
					Munitions_anz();
				}
			}
			
			wait(1);
		}
		wait(1);
	}
}




action Testgegner
{
	bots[Bot_Nr] = handle(my);
	Bot_Nr += 1;
	my.health = 100;
	my.polygon = on;
	my.fat = off;
	my.narrow = off;
	my.oberflache = Haut;
	
	if(my.skill1 == 0){my.skill1 = 0.1;}
	if(my.skill2 == 0){my.skill2 = 200;}
	if(my.skill3 == 0){my.skill3 = 70;}
	if(my.skill4 == 0){my.skill4 = 25;}
	if(my.string1 == 0){my.string1 = "Huelse.mdl";}
	
	while(my.Health > 0)
	{
		vec_set(temp,player.x);	
		vec_sub(temp,my.x);
 		vec_to_angle(my.pan,temp);

		wait(1);
	}
	
	while(my.skill30 < 100)
	{
		c_updatehull(my,37);
		ent_animate(my,"death",my.skill30,NULL);
		my.skill30 += 5*time;
		wait(1);
	}
	c_updatehull(my,41);
	sleep(10);
	ent_remove(me);
}